/*                               menustuff.h                            */
/*                                                                      */
/* This is menustuff.h: contains Menu and MenuItem structures for my    */
/* very first game...                                                   */



/* These are all the IntuiText structures */

struct IntuiText programtext[] = {
   {0, 1, JAM2, 1, 1, NULL, "Thanks   ", NULL},
   {0, 1, JAM2, 1, 1, NULL, "About    ", NULL},
   {0, 1, JAM2, 1, 1, NULL, "Exit     ", NULL}
   };

struct IntuiText gametext[] = {
   {0, 1, JAM2, 1, 1, NULL, "Start ", NULL},
   {0, 1, JAM2, 1, 1, NULL, "Peek  ", NULL},
   {0, 1, JAM2, 1, 1, NULL, "Quit  ", NULL}
   };

struct IntuiText leveltext[] = {
   {0, 1, JAM2, 1, 1, NULL, "  Easy   ", NULL},
   {0, 1, JAM2, 1, 1, NULL, "  Normal ", NULL},
   {0, 1, JAM2, 1, 1, NULL, "  Hard   ", NULL}
   };

struct IntuiText opponenttext[] = {
   {0, 1, JAM2, 1, 1, NULL, "  Amiga   ", NULL},
   {0, 1, JAM2, 1, 1, NULL, "  Human   ", NULL}
   };



/* These are all the MenuItem structures */

struct MenuItem programitem[] = {
   {&programitem[1],
   0, 0,
   72, 10,
   HIGHCOMP | ITEMTEXT | ITEMENABLED,
   0,
   (APTR)&programtext[0],
   NULL,
   0,
   NULL,
   0},

   {&programitem[2],
   0, 10,
   72, 10,
   HIGHCOMP | ITEMTEXT | ITEMENABLED,
   0,
   (APTR)&programtext[1],
   NULL,
   0,
   NULL,
   0},

   {NULL,
   0, 20,
   72, 10,
   HIGHCOMP | ITEMTEXT | ITEMENABLED,
   0,
   (APTR)&programtext[2],
   NULL,
   0,
   NULL,
   0}
   };

struct MenuItem gameitem[] = {
   {&gameitem[1],
   0, 0,
   48, 10,
   HIGHCOMP | ITEMTEXT | ITEMENABLED,
   0,
   (APTR)&gametext[0],
   NULL,
   0,
   NULL,
   0},

   {&gameitem[2],
   0, 10,
   48, 10,
   HIGHCOMP | ITEMTEXT,
   0,
   (APTR)&gametext[1],
   NULL,
   0,
   NULL,
   0},

   {NULL,
   0, 20,
   48, 10,
   HIGHCOMP | ITEMTEXT,
   0,
   (APTR)&gametext[2],
   NULL,
   0,
   NULL,
   0}
   };

struct MenuItem levelitem[] = {
   {&levelitem[1],
   0, 0,
   72, 10,
   HIGHCOMP | ITEMTEXT | ITEMENABLED | CHECKIT | CHECKED,
   0xfffe,
   (APTR)&leveltext[0],
   NULL,
   0,
   NULL,
   0},

   {&levelitem[2],
   0, 10,
   72, 10,
   HIGHCOMP | ITEMTEXT | ITEMENABLED | CHECKIT,
   0xfffd,
   (APTR)&leveltext[1],
   NULL,
   0,
   NULL,
   0},

   {NULL,
   0, 20,
   72, 10,
   HIGHCOMP | ITEMTEXT | ITEMENABLED | CHECKIT,
   0xfffb,
   (APTR)&leveltext[2],
   NULL,
   0,
   NULL,
   0},
   };

struct MenuItem opponentitem[] = {
   {&opponentitem[1],
   0, 0,
   80, 10,
   HIGHCOMP | ITEMTEXT | ITEMENABLED | CHECKIT | CHECKED,
   0xfffe,
   (APTR)&opponenttext[0],
   NULL,
   0,
   NULL,
   0},

   {NULL,
   0, 10,
   80, 10,
   HIGHCOMP | ITEMTEXT | ITEMENABLED | CHECKIT,
   0xfffd,
   (APTR)&opponenttext[1],
   NULL,
   0,
   NULL,
   0},
   };



/* These are all the Menu structures */

struct Menu mygamemenu[] = {
   {&mygamemenu[1],
   2, 0,
   72, 8,
   MENUENABLED,
   " Program ",
   &programitem[0],
   NULL, NULL,
   NULL, NULL},

   {&mygamemenu[2],
   76, 0,                  /* 2 + 72 + 2 */
   48, 8,
   MENUENABLED,
   " Game ",
   &gameitem[0],
   NULL, NULL,
   NULL, NULL},

   {&mygamemenu[3],
   126, 0,                 /* 2 + 72 + 2 + 48 + 2 */
   72, 8,
   MENUENABLED,
   "  Level  ",
   &levelitem[0],
   NULL, NULL,
   NULL, NULL},

   {NULL,
   200, 0,                 /* 2 + 72 + 2 + 48 + 2 + 72 + 2 */
   80, 8,
   MENUENABLED,
   " Opponent ",
   &opponentitem[0],
   NULL, NULL,
   NULL, NULL}
   };
